#include "local.h"
#include <stdio.h>
#include <math.h>
#include "son.h"
#include "em.typ"

#include "hardlock.h"
#include "hl.h"

int *find_ipts();
int *add_ipts();
int *rm_ipts();
int chsm_value;

extern char prog_name[];

pcir2cir(cir,Box)  Cir *cir;  Box_info *Box;
/*************************************************************/
/* Add msubs to lev covering all polys.                      */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03may89 */ 
{ msub_list *lev;
  Poly_list *plev;
  Rpoly *rpoly;
  Ipoly *ipoly;
  int i,mode,cx0,cy0,ilev;
  Ipts *rects;  /*List of rectangles covering polys on lev*/
  Ipts *dupe;   /*Dupe list of cells already done on level*/
  Ipts *cells;  /*List of cells in present polygon*/
  /*Allocate memory for above structures when the proc is invoked*/
  Ipts rects_struct,dupe_struct,cells_struct;
  int ck_rect();
  int cmp_yx();

  for (lev=cir->lev0; lev<cir->lev0+cir->n; lev++)
  { clear_lev(lev);  init_lev(lev); }
  /*The last cir lev is for vias (to gnd) only*/

  /*Add in all vias*/
  add_vias(cir,Box);

  /*Convert (update) port info*/
  port2cir(cir,Box);

  /*Genrate outlines (including gnd plane, so cond_index can get via conductivity*/
  for (plev=cir->plev0,lev=cir->lev0; plev<cir->plev0+cir->n; plev++,lev++)
  { for (i=0; i<plev->n; i++)  
    { rpoly = plev->rpoly0 + i;  ipoly = plev->ipoly0 + i;
      /*Decode the mode and save*/
      mode = rpoly->mode;
      rpoly->mode = (mode & TRI_FILL) ? DIAGONAL : STAIRCASE;
      poly_rtoi(rpoly,ipoly,Box->A/Box->Capm,Box->B/Box->Capn);
      rpoly->mode = mode;
    }
  }
  /*Do corner and triangle fill on all but ground plane level*/
  for (plev=cir->plev0,lev=cir->lev0; plev<cir->plev0+cir->n-1; plev++,lev++)
  { for (i=0; i<plev->n; i++)
    { if ((plev->rpoly0+i)->mode & COR_FILL)
      { /*Dist from corner for edge subsections*/
	cx0 = Box->msub_per * Box->max_xinc / 10;
	if (cx0>10) cx0 = 10;  if (cx0<2) cx0 = 2;
    	cy0 = Box->msub_per * Box->max_yinc / 10;
  	if (cy0>10) cy0 = 10;  if (cy0<2) cy0 = 2;
        cor_fill(plev->ipoly0+i,lev,plev,Box,cx0,cy0);
      }
      if ((plev->rpoly0+i)->mode & TRI_FILL) tri_fill(plev->ipoly0+i,lev,plev,Box);
    }
  }

  /* DOS SECURITY */
#ifdef DOS
    /* chsm_value should be 30 */
    if ( (chsm_value % 11)*3 /5 == 4 )
    { int port;
      int hladdress = HL_ADDRESS;
      int registr;
      int  tmpdatastr[16],status,blkcnt;
      int *fnc_hlcrypt = (int *)hlcrypt +1023;
      int *fnc_intoff = (int *)intoff +1023;
      int *fnc_hlon = (int *)hlon +1023;
      int *fnc_hlrwd = (int *)hlrwd +511;
      int *fnc_hloff = (int *)hloff +1023;
      int *fnc_inton = (int *)inton +1023;

      port = 0;
      blkcnt = 1;
      registr = HL_LOC_512;
      strcpy(tmpdatastr,"rspndjxy");
	
      ((void (*)()) (fnc_hlcrypt-1023)) (&status,&port,&hladdress,tmpdatastr,&blkcnt);
      if ( status == 0 ) {
        /* Turn off interrupts */
        ((void (*)()) (fnc_intoff-1023)) ();
        ((void (*)()) (fnc_hlon-1023))(&port,&hladdress);

        /* Turn on hardlock */
        ((void (*)()) (fnc_hlrwd-511))(&port,&registr,&cx0);

        /* Turn on the interrupts */
        ((void (*)()) (fnc_hloff-1023))(&port);
        ((void (*)()) (fnc_inton-1023))();
      }
      /* The following is equivelent code.  Change the code to make it more
      * difficult for a hacker to find it.
      * port = 0;
      * blkcnt = 1;
      * strcpy(tmpdatastr,"rspndjxy");
      * hlcrypt (&status,&port,&hladdress,tmpdatastr,&blkcnt);
      *
      * if ( status == 0 ) {
      *   intoff();
      *   hlon(&port,&hladdress);
      *
      *   registr = HL_LOC_101;
      *   hlrwd(&port,&registr,&i);
      *
      *   hloff(&port);
      *   inton();
      * }
      */
    }


#else /* UNIX */
      cx0 = 512;
#endif /* DOS */

  rects = &rects_struct; /*list of rects used to build subsections*/
  init_ipts(rects,4);  /*4 ints/pt, xa,ya,xb,yb*/
  rects->rules = ck_rect;
  dupe = &dupe_struct; /*So no cell is used twice*/
  init_ipts(dupe,2);  /*2 ints/pt, xa,ya; center of cell*/
  dupe->cmp_func = cmp_yx; /*So will use binary search when dupe-ing*/
  cells = &cells_struct; /*list of cells in given poly*/
  init_ipts(cells,2);  /*2 ints/pt, xa,ya; center of cell*/
  /*Generate all remaining msubs*/
  for (ilev=0; ilev<cir->n-1; ilev++)
  { lev = cir->lev0 + ilev;
    plev = cir->plev0 + ilev;
    init_ckvert(cir->plev0,ilev,cir->n,Box);
    for (i=plev->n-1; i>=0; i--) /*Pick up any via polgons first*/
    { ipoly = plev->ipoly0 + i;
      rpoly = plev->rpoly0 + i;
      /*Get the cells in ipoly which are not in dupe list and udate dupe*/
      get_cells(Box->Capm,Box->Capn,ipoly,cells,dupe);
      /*Use cell list to generate rects and add to rect list*/
      form_rects(cells,rects,Box,rpoly);
      /*clear out cell list for next polygon*/
      clear_ipts(cells);
    }
    clear_ipts(dupe);
    add_port_cells(rects,cir->ports,lev-cir->lev0);

    /* DOS SECURITY */
    rects->n -= ( 4096 - 8 * cx0 ) ? rects->n / 2 : 0 ;

    form_xmsubs(rects,Box,lev);
    form_ymsubs(rects,Box,lev);
    ck_ovrlap(lev);

    /* DOS SECURITY */
    rects->n += ( 4096 - 8 * cx0 ) ? rects->n / 2 : 0 ;

    ck_orphan(rects,Box,lev,ilev);
    clear_ipts(rects);
  }

} /*pcir2cir*/

add_port_cells(rects,ports,ilev) Ipts *rects;  port_list *ports; int ilev;
/*************************************************************/
/* Add cells on both sides of any ports.                     */
/* (C) COPYRIGHT 1991 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29may91 */
{ int i,j,lim,ip[4];
  int *ipt;
  port_typ *port;

  for (i=0; i<ports->n; i++)
  { port = ports->port0+i;
    if (port->ilev == ilev)
      for (j=0; j<rects->n; j++) /*Search for rectangles next to port*/
      { ipt = rects->ipt0 + j * rects->size;  /*ipt0 might chng during loop*/

        if (port->x0 == port->x1)      /*vertical port*/
        { if ( *ipt == port->x0 &&     /*rect on right side of port*/
	       *(ipt+1) < port->y1 && *(ipt+3) > port->y0 ) /*rect touches port*/
          { lim = *(ipt+3);            /*y limit for generating port cell rects*/
            ip[0] = *ipt;              /*low x coord for port cell rects*/
            ip[2] = ip[0] + 2;         /*high x coord for port cell rects*/
            if ( *(ipt+2) - *ipt > 2 ) /*Existing rect is wider than one cell,*/
	    { *ipt += 2;               /*so back off edge by two*/
              ip[1] = *(ipt+1);
            }
	    else /*Make rect first port cell rect*/
              ip[1] = *(ipt+3) = *(ipt+1) + 2;
            if ( *(ipt+3) > lim ) *(ipt+3) = lim;  /*in case odd cells/side and sym*/
            ip[3] = ip[1] + 2;
            for ( ; ip[1]<lim; ip[1]+=2,ip[3]+=2 )
	    { if ( ip[3] > lim ) ip[3] = lim;      /*ditto*/
              add_ipts(rects,ip);
            }
          } /*if*/

          else if ( *(ipt+2) == port->x0 &&         /*rect on left side of port*/
	       *(ipt+1) < port->y1 && *(ipt+3) > port->y0 ) /*rect touches port*/
          { lim = *(ipt+3);            /*y limit for generating port cell rects*/
            ip[2] = *(ipt+2);          /*high x coord for port cell rects*/
            ip[0] = ip[2] - 2;         /*low x coord for port cell rects*/
            if ( *(ipt+2) - *ipt > 2 ) /*Existing rect is wider than one cell,*/
	    { *(ipt+2) -= 2;           /*so back off edge by two*/
              ip[1] = *(ipt+1);
            }
	    else /*Make rect first port cell rect*/
              ip[1] = *(ipt+3) = *(ipt+1) + 2;
            if ( *(ipt+3) > lim ) *(ipt+3) = lim;  /*in case odd cells/side and sym*/
            ip[3] = ip[1] + 2;
            for ( ; ip[1]<lim; ip[1]+=2,ip[3]+=2 )
	    { if ( ip[3] > lim ) ip[3] = lim;      /*ditto*/
              add_ipts(rects,ip);
            }
          } /*if*/
        } /*else if, for*/

        else if (port->y0 == port->y1)     /*horizontal port*/
        { if ( *(ipt+1) == port->y0 &&     /*rect on bottom (high coord) side of port*/
	       *ipt < port->x1 && *(ipt+2) > port->x0 ) /*rect touches port*/
          { lim = *(ipt+2);                /*x limit for generating port cell rects*/
            ip[1] = *(ipt+1);              /*low y coord for port cell rects*/
            ip[3] = ip[1] + 2;             /*high y coord for port cell rects*/
            if ( *(ipt+3) - *(ipt+1) > 2 ) /*Existing rect is wider than one cell,*/
	    { *(ipt+1) += 2;               /*so back off edge by two*/
              ip[0] = *ipt;
            }
	    else /*Make rect first port cell rect*/
              ip[0] = *(ipt+2) = *ipt + 2;
            ip[2] = ip[0] + 2;
            for ( ; ip[0]<lim; ip[0]+=2,ip[2]+=2 )
              add_ipts(rects,ip);
          } /*if*/

          else if ( *(ipt+3) == port->y0 &&  /*rect on top (high coord) side of port*/
	       *ipt < port->x1 && *(ipt+2) > port->x0 ) /*rect touches port*/
          { lim = *(ipt+2);                /*x limit for generating port cell rects*/
            ip[3] = *(ipt+3);              /*high y coord for port cell rects*/
            ip[1] = ip[3] - 2;             /*low y coord for port cell rects*/
            if ( *(ipt+3) - *(ipt+1) > 2 ) /*Existing rect is wider than one cell,*/
	    { *(ipt+3) -= 2;               /*so back off edge by two*/
              ip[0] = *ipt;
            }
	    else /*Make rect first port cell rect*/
              ip[0] = *(ipt+2) = *ipt + 2;
            ip[2] = ip[0] + 2;
            for ( ; ip[0]<lim; ip[0]+=2,ip[2]+=2 )
              add_ipts(rects,ip);
          } /*if*/

        }
    
      } /*if port, for j*/
  } /*for i*/
} /*add_port_cells*/

form_xmsubs(rects,box,lev) Ipts *rects;  Box_info *box;  msub_list *lev;
/*************************************************************/
/* Set up all the X directed msubs.                          */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr09oct90 */ 
{ int *ip,*jp,i,key[4],size,xy[6];
  int cmpyrect();

  size = rects->size;  /*ints per rect, == 4*/
  sort_ipts(rects,cmpyrect);

  for (i=0; i<rects->n; i++)
  { ip = rects->ipt0 + i*size;  jp = ip + size;
    /* *ip==xlow,*(ip+1)==ylow,*(ip+2)==xhigh,*(ip+3)==yhigh*/
    /*add msub if next rect is perfectly adjacent, most common case*/
    if ( i<rects->n-1 &&
         *(ip+2) == *jp && *(ip+1) == *(jp+1) && *(ip+3) == *(jp+3) )
    { xy[0] = *ip;  xy[1] = *(ip+1);
      xy[2] = *(jp+2);  xy[3] = *(ip+3);
      xy[4] = *jp; xy[5] = 0;
      add_msub(MXR,xy,box,lev);
    }
    else if (*(ip+2)==box->Capm) /*Ground on high x side*/
    { xy[0] = *ip;  xy[1] = *(ip+1);
      xy[2] = box->Capm + 2;  xy[3] = *(ip+3);
      xy[4] = box->Capm;  xy[5] = 0;
      add_msub(MXR,xy,box,lev);
    }
    else /*search for any x dir msubs with peak on high x side*/
    { key[0] = key[2] = *(ip+2) + 1;
      key[1] = key[3] = *(ip+1) + 1;
      jp = (int *)lfind( (char *)key,            /*bsearch in ipts_find*/
                         (char *)rects->ipt0,    /*can't find rect which*/
                         &(rects->n),            /*contains pt ikey nw&then*/
                         rects->size * sizeof(int),
                         rects->cmp_func            );
      if (jp != NULL) /*Found adjacent rect, add in msub*/
      { xy[0] = *ip;
        xy[1] = ( *(ip+1) < *(jp+1) ) ? *(ip+1) : *(jp+1);
        xy[2] = *(jp+2);
        xy[3] = ( *(ip+3) > *(jp+3) ) ? *(ip+3) : *(jp+3);
        xy[4] = *jp; xy[5] = 0;
        add_msub(MXR,xy,box,lev);
      }
    }

    /*Check for ground on low x side*/
    if (*ip==0)
    { xy[0] = -2;  xy[1] = *(ip+1);
      xy[2] = *(ip+2);   xy[3] = *(ip+3);
      xy[4] = 0;   xy[5] = 0;
      add_msub(MXR,xy,box,lev);
    }
  } /*for*/
} /*form_xmsubs*/

form_ymsubs(rects,box,lev) Ipts *rects;  Box_info *box;  msub_list *lev;
/*************************************************************/
/* Set up all the Y directed msubs.                          */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr09oct90 */ 
{ int *ip,*jp,i,key[4],size,xy[6];
  int cmpxrect();

  size = rects->size;  /*ints per rect, == 4*/
  sort_ipts(rects,cmpxrect);

  for (i=0; i<rects->n; i++)
  { ip = rects->ipt0 + i*size;  jp = ip + size;
    /* *ip==xlow,*(ip+1)==ylow,*(ip+2)==xhigh,*(ip+3)==yhigh*/
    /*add msub if next rect is perfectly adjacent, most common case*/
    if ( i<rects->n-1 &&
         *(ip+3) == *(jp+1) && *ip == *jp && *(ip+2) == *(jp+2) )
    { xy[0] = *ip;  xy[1] = *(ip+1);
      xy[2] = *(ip+2);  xy[3] = *(jp+3);
      xy[4] = 0; xy[5] = *(jp+1);
      add_msub(MYR,xy,box,lev);
    }
    else if (*(ip+3)==box->Capn) /*Ground on high y side*/
    { xy[0] = *ip; xy[1] = *(ip+1);
      xy[2] = *(ip+2);  xy[3] = box->Capn + 2;
      xy[4] = 0;  xy[5] = box->Capn;
      add_msub(MYR,xy,box,lev);
    }
    else /*search for any y dir msubs with peak on high y side*/
    { key[0] = key[2] = *ip + 1;
      key[1] = key[3] = *(ip+3) + 1;
      jp = (int *)lfind( (char *)key,            /*bsearch in ipts_find*/
                         (char *)rects->ipt0,    /*can't find rect which*/
                         &(rects->n),            /*contains pt ikey nw&then*/
                         rects->size * sizeof(int),
                         rects->cmp_func            );
      if (jp != NULL) /*Found adjacent rect, add in msub*/
      { xy[0] = ( *ip < *jp) ? *ip : *jp;
        xy[1] = *(ip+1);
        xy[2] = ( *(ip+2) > *(jp+2) ) ? *(ip+2) : *(jp+2);
        xy[3] = *(jp+3);
        xy[4] = 0; xy[5] = *(jp+1);
        add_msub(MYR,xy,box,lev);
      }
    }

    /*Check for ground on low y side*/
    if ( *(ip+1) == 0 )
    { xy[0] = *ip;  xy[1] = -2;
      xy[2] = *(ip+2);  xy[3] = *(ip+3);
      xy[4] = 0;  xy[5] = 0;
      add_msub(MYR,xy,box,lev);
    }
  } /*for*/
} /*form_mysubs*/

ck_ovrlap(lev)  msub_list *lev;
/*************************************************************/
/* Check for any msubs which overlapp.                       */
/* (C) COPYRIGHT 1993 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr06may93 */ 
{ int im,in,mx0,my0;
  msub *mp,*np;

  /*Presently set up to handle only restricted case of complete and
  exact overlapp except on one side*/

  /*im stop limit is one less cause no need to ck vry last one*/
  for ( im=0; im<lev->n-1; im++)
    for ( in=im+1; in<lev->n; in++)
    { mp = lev->msub0 + im;  /*For robustness...*/
      np = lev->msub0 + in;  /*in future version, msub0 could change during loop*/

      if ( mp->id == MXR && np->id == MXR &&
	   *mp->ip == *np->ip && *(mp->ip+2) == *(np->ip+2) )
      { if ( *(mp->ip+1) == *(np->ip+1) )
        { if ( *(mp->ip+3) > *(np->ip+3) )
	    *(mp->ip+1) = *(np->ip+3);
          else if ( *(np->ip+3) > *(mp->ip+3) )
	    *(np->ip+1) = *(mp->ip+3);
        }
        else if ( *(mp->ip+3) == *(np->ip+3) )
        { if ( *(mp->ip+1) < *(np->ip+1) )
	    *(mp->ip+3) = *(np->ip+1);
          else if ( *(np->ip+1) < *(mp->ip+1) )
	    *(np->ip+3) = *(mp->ip+1);
        }
      }

      if ( mp->id == MYR && np->id == MYR &&
	   *(mp->ip+1) == *(np->ip+1) && *(mp->ip+3) == *(np->ip+3) )
      { if ( *mp->ip == *np->ip )
        { if ( *(mp->ip+2) > *(np->ip+2) )
	    *mp->ip = *(np->ip+2);
          else if ( *(np->ip+2) > *(mp->ip+2) )
	    *np->ip = *(mp->ip+2);
        }
        else if ( *(mp->ip+2) == *(np->ip+2) )
        { if ( *mp->ip < *np->ip )
	    *(mp->ip+2) = *np->ip;
          else if ( *np->ip < *mp->ip )
	    *(np->ip+2) = *mp->ip;
        }
      }

    }

  /*Remove triangle subs which are completely covered by rectangle subs*/
  for (im=0; im<lev->n; im++)
  { mp = lev->msub0 + im;
    if ( mp->id == MTPP || mp->id == MTNN || mp->id == MTNP || mp->id == MTPN )
    { mx0 = *(mp->ip);  my0 = *(mp->ip+1);
      for (in=0; in<lev->n; in++)
      { np = lev->msub0 + in;
        if ( (np->id == MXR || np->id == MYR) &&
	     *(np->ip+MX0) < mx0 && *(np->ip+MX1) > mx0 &&
	     *(np->ip+MY0) < my0 && *(np->ip+MY1) > my0 )
        { remove_msub(mp,lev);
	  im--;  
	  break;
        }
      }
    }
  }

} /*ck_ovrlap*/

ck_orphan(rects,Box,lev,ilev)
   Ipts *rects;  Box_info *Box;  msub_list *lev;  int ilev;
/*************************************************************/
/* Check for any rect with no subs on it.                    */
/* (C) COPYRIGHT 1990 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr09oct90 */ 
{ int i,found,rx0,ry0,rx1,ry1,mx0,my0;
  int *ip,*ip_stop;
  msub *mp,*mp_stop;
  Rtyp dx,dy;

  dx = Box->A / (Box->Capm * Box->Lcnv);
  dy = Box->B / (Box->Capn * Box->Lcnv);

  ip_stop = rects->ipt0 + rects->size * rects->n;
  mp_stop = lev->msub0 + lev->n;

  for ( ip=rects->ipt0; ip<ip_stop; ip += rects->size )
  { rx0 = *ip;      ry0 = *(ip+1);  /*low value corner*/
    rx1 = *(ip+2);  ry1 = *(ip+3);  /*high value corner*/
    found = 0;
    for ( mp=lev->msub0; mp<mp_stop && !found; mp++)
    { if ( mp->id == MXR )
      { mx0 = *(mp->ip+4);
	my0 = *(mp->ip+1);
	if ( ( mx0 == rx0 || mx0 == rx1 ) && my0 == ry0 )
	  found = 1;
      }
      else if ( mp->id == MYR )
      { mx0 = *mp->ip;
	my0 = *(mp->ip+5);
	if ( ( my0 == ry0 || my0 == ry1 ) && mx0 == rx0 )
	  found = 1;
      }
      else if ( mp->id == MVIA )
      { mx0 = *mp->ip;
	my0 = *(mp->ip+1);
      }
      else  /*ck triangles and vias*/
      { mx0 = *mp->ip;
	my0 = *(mp->ip+1);

	switch (mp->id)
        { case MVIA : if ( my0 < ry1 && my0 > ry0 &&
			   mx0 < rx1 && mx0 > rx0 )
	                found = 1;
                      break;
	  case MTPP : if ( mx0 == rx1+1 && my0 < ry1 && my0 > ry0 )  /*low x tab*/
	                found = 1;
		      if ( my0 == ry0-1 && mx0 < rx1 && mx0 > rx0 )  /*high y tab*/
			found = 1;
                      break;
	  case MTPN : if ( mx0 == rx1+1 && my0 < ry1 && my0 > ry0 )  /*low x tab*/
	                found = 1;
		      if ( my0 == ry1+1 && mx0 < rx1 && mx0 > rx0 )  /*low y tab*/
			found = 1;
                      break;
	  case MTNP : if ( mx0 == rx0-1 && my0 < ry1 && my0 > ry0 )  /*high x tab*/
	                found = 1;
		      if ( my0 == ry0-1 && mx0 < rx1 && mx0 > rx0 )  /*high y tab*/
			found = 1;
                      break;
	  case MTNN : if ( mx0 == rx0-1 && my0 < ry1 && my0 > ry0 )  /*high x tab*/
	                found = 1;
		      if ( my0 == ry1+1 && mx0 < rx1 && mx0 > rx0 )  /*low y tab*/
			found = 1;
                      break;
	} /*switch*/
      }

    }
    if ( !found )
    { fprintf(stderr,"\n%s: Warning, no subsections in rectangular area, location:\n",
	prog_name);
      fprintf(stderr,"    level %d, (%lf,%lf) to (%lf,%lf) %s, %s.\n",
	ilev,rx0*dx,ry0*dy,rx1*dx,ry1*dy,Box->Lstr,Box->file);
      Box->orphan = 1;
    }
  }
} /*ck_orphan*/

get_cells(xlim,ylim,ipoly,cells,dupe)  int xlim,ylim;  Ipoly *ipoly;  Ipts *cells,*dupe;
/*************************************************************/
/* Return list of all cells in ipoly except those in dupe.   */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29jan92 */
{ int x0,x1,y,cells_found;
  int *xyp,*xy_stop;
  int ikey[2];

  xy_stop = ipoly->xy0 + 2 * ipoly->n;
  for (xyp=ipoly->xy0; xyp+2<xy_stop; xyp += 2) if (*(xyp+1) == *(xyp+3))
  { x0 = *xyp;  y = *(xyp+1);
    x1 = *(xyp+2);
    if (x0>x1) { x0 = *(xyp+2);  x1 = *xyp; }
    /*always look on low (increasing y) side of x dir line*/
    cells_found = 1;
    ikey[1] = y+1;
    while (cells_found)
    { cells_found = 0;
      for (ikey[0]=x0+1; ikey[0]<x1; ikey[0] += 2)
	if ( pt_in_ipoly(ipoly,ikey[0],ikey[1]) )
        { cells_found = 1;
          if ( ikey[0]>0 && ikey[0]<xlim && ikey[1]>0 && ikey[1]<ylim &&
               find_ipts(dupe,ikey) == NULL )
          { add_ipts(cells,ikey);
            add_ipts(dupe,ikey);
          }
        }
      ikey[1] += 2;
    }
  }
} /*get_cells*/

form_rects(cells,rects,Box,rpoly)  Ipts *cells,*rects;  Box_info *Box;  Rpoly *rpoly;
/*************************************************************/
/* Adds rectangles covering poly to rects list.              */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr29jan92 */
{ int ylim,size;
  int *xpk0,*ypk0,*xpk,*ypk;
  int *div0,*div1,*div2,*div3;  /*Stores how big rect subsectioned*/
  int ndiv0,ndiv1,ndiv2,ndiv3;  /*Stores number of divisions*/
  int mdiv0,mdiv1,mdiv2,mdiv3;  /*Stores index of midpt of divisions*/
  int big_rect[4];
  int x0,y0,x1,y1; /*Stores big_rect pts in scalar form*/
  int key[4],delta;
  int *iyp,*ixp;
  int manhatten;  /*Is the polygon manhatten?*/

  if (cells->n < 1) return;

  /*Set up x and y msub peaks*/
  /*There should never be more than what's allocated here*/
  size = (Box->Capm>Box->Capn) ? Box->Capm : Box->Capn;
  size = 4 + size/2;
  xpk0 = (int *)new(size*sizeof(int));  /*Longitudinal peak inc's*/
  ypk0 = (int *)new(size*sizeof(int));  /*Longitudinal peak inc's*/
  div0 = (int *)new(size*sizeof(int));  /*Side 0 subsection info*/
  div1 = (int *)new(size*sizeof(int));  /*Side 1 subsection info*/
  div2 = (int *)new(size*sizeof(int));  /*Side 2 subsection info*/
  div3 = (int *)new(size*sizeof(int));  /*Side 3 subsection info*/

  /*If the polygon is manhatten, xmin and ymin can be used on edge*/
  manhatten = ck_manhatten(rpoly,Box);

  /*xpk0 is a list of inc's in x direction*/
  setup_pk(rpoly->xmin,rpoly->xmax,Box->max_xinc,manhatten,size,xpk0);
  /*ypk0 is a list of inc's in y direction*/
  setup_pk(rpoly->ymin,rpoly->ymax,Box->max_yinc,manhatten,size,ypk0);

  /*If symmetry, don't add any rects with min y coord greater than ylim*/
  ylim = (Box->Xsym) ? Box->Capn/2 : Box->Capn;

  /************ Big Rect Sides ************

                 Side 2 (div2)
           *----------------------*
           |                      |
   Side 0  |                      | Side 1
   (div0)  |                      | (div1)
           *----------------------*
                 Side 3 (div3)
   (Increasing Y is down)

   *****************************************/

  /*Main Rectangle Forming Loop*/
  while (cells->n > 0)
  { find_big_rect(cells,big_rect);

    x0 = big_rect[0];  y0 = big_rect[1];
    x1 = big_rect[2];  y1 = big_rect[3];

    if ( (y1-y0) <= 4 ) /*Horz. big_rect 1 or 2 cells wide*/
    { ndiv2 = div_x(x0,y0,x1,(y1-y0),xpk0,div2);
      for (ixp=div2; ixp<div2+ndiv2-1; ixp++)
      { key[0] = *ixp;  key[1] = y0;
        key[2] = *(ixp+1);  key[3] = y0+2;
        if (key[3]>ylim) key[3] = ylim;
        if (key[3]>key[1]) add_ipts(rects,key);
        if ( (y1-y0)==4 )
        { key[1] += 2;  key[3] += 2;
          if (key[3]>ylim) key[3] = ylim;
          if (key[3]>key[1]) add_ipts(rects,key);
        }
      }
    }

    else if ( (x1-x0) <= 4 ) /*Vert. big_rect 1 or 2 cells wide*/
    { ndiv0 = div_y(x0,y0,(x1-x0),y1,ypk0,div0);
      for (iyp=div0; iyp<div0+ndiv0-1; iyp++) if (*iyp < ylim)
      { key[0] = x0;  key[1] = *iyp;
        key[2] = x0+2;  key[3] = *(iyp+1);
        if (key[3]>ylim) key[3] = ylim;
        if (key[3]>key[1]) add_ipts(rects,key);
        if ( (x1-x0)==4 )
        { key[0] += 2;  key[2] += 2;
          if (key[3]>ylim) key[3] = ylim;
          if (key[3]>key[1]) add_ipts(rects,key);
        }
      }
    }

    else /*big_rect has more than 2 cells in both dimenions*/
    { delta = ( x1-x0 <= *xpk0 ) ? x1-x0 : x1-x0-2;
      ndiv0 = div_y(x0,y0,delta,y1,ypk0,div0);
      ndiv1 = div_y(x1,y0,-delta,y1,ypk0,div1);

      delta = ( y1-y0 <= *ypk0 ) ? y1-y0 : y1-y0-2;
      ndiv2 = div_x(x0,y0,x1,delta,xpk0,div2);
      ndiv3 = div_x(x0,y1,x1,-delta,xpk0,div3);

      /*Determine non-overlapping mid-points for each side*/
      div_midpt(div0,div1,&ndiv0,&ndiv1,&mdiv0,&mdiv1);
      div_midpt(div2,div3,&ndiv2,&ndiv3,&mdiv2,&mdiv3);

      /*Make the rectangles*/
      iyp = div0;
      while ( iyp < div0+mdiv0 )  /*Top, left portion of big_rect*/
      { key[1] = *iyp;  key[3] = *(iyp+1);
        if (key[3]>ylim) key[3] = ylim;
        ixp = div2;
        if (key[3]>key[1]) while ( ixp < div2+mdiv2 )
        { key[0] = *ixp;  key[2] = *(ixp+1);
          add_ipts(rects,key);
          ixp++;
        }
        iyp++;
      }

      iyp = div1;
      while ( iyp < div1+mdiv1 )  /*Top, right portion of big_rect*/
      { key[1] = *iyp;  key[3] = *(iyp+1);
        if (key[3]>ylim) key[3] = ylim;
        ixp = div2 + mdiv2;
        if (key[3]>key[1]) while ( ixp < div2+ndiv2-1 )
        { key[0] = *ixp;  key[2] = *(ixp+1);
          add_ipts(rects,key);
          ixp++;
        }
        iyp++;
      }

      iyp = div0 + mdiv0;
      while ( iyp < div0+ndiv0-1 )  /*Bottom, left portion of big_rect*/
      { key[1] = *iyp;  key[3] = *(iyp+1);
        if (key[3]>ylim) key[3] = ylim;
        ixp = div3;
        if (key[3]>key[1]) while ( ixp < div3+mdiv3 )
        { key[0] = *ixp;  key[2] = *(ixp+1);
          add_ipts(rects,key);
          ixp++;
        }
        iyp++;
      }

      iyp = div1 + mdiv1;
      while ( iyp < div1+ndiv1-1 )  /*Bottom, right portion of big_rect*/
      { key[1] = *iyp;  key[3] = *(iyp+1);
        if (key[3]>ylim) key[3] = ylim;
        ixp = div3 + mdiv3;
        if (key[3]>key[1]) while ( ixp < div3+ndiv3-1 )
        { key[0] = *ixp;  key[2] = *(ixp+1);
          add_ipts(rects,key);
          ixp++;
        }
        iyp++;
      }

    }

    /*Make sure all rect regions are properly attached*/
    if ( x1-x0 > 4  && y1-y0 > 4 )
    { attach1(rects,y0,*(div0+mdiv0),*(div2+mdiv2));
      attach0(rects,*(div1+mdiv1),y1,*(div3+mdiv3));
      attach2(rects,x0,*(div3+mdiv3),*(div0+mdiv0));
      attach3(rects,*(div2+mdiv2),x1,*(div1+mdiv1));
    }
    attach0(rects,y0,y1,x0);
    attach1(rects,y0,y1,x1);
    attach2(rects,x0,x1,y0);
    attach3(rects,x0,x1,y1);

  } /*while(cells->n>0)*/

  /*Free up allocated memory*/
  sFree((char *)xpk0);
  sFree((char *)ypk0);
  sFree((char *)div0);
  sFree((char *)div1);
  sFree((char *)div2);
  sFree((char *)div3);
} /*form_rects*/

int div_x(x0,y0,x1,dy,pk0,divp) int x0,y0,x1,dy,*pk0,*divp;
/*************************************************************/
/* Return divp,ndiv with gud sub divisions for rects.        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03feb92 */
{ int *pk;
  int xa0,xb0,xa1,xb1;  /*2 x + x0 for msub coord*/
  int xbeg,xend,dist;
  int cmp_int();
  int ndiv;

  if ( x0 > x1 )
  { xa0 = x1;  x1 = x0;  x0 = xa0; }

  if ( x0 == x1 )  /*Nothing to do*/
  { return(0); }

  *divp = x0;
  *(divp+1) = x1;
  ndiv = 2;

  /*a is start, b is end of line segment*/
  /*x-0 is low end, x-1 is high end*/
  xa0 = xb0 = 0;  /*2 x then add x0 for msub coords*/
  xa1 = xb1 = 0;  /*ditto*/
  xbeg = x0;  /*Begining of uniform section*/
  xend = x0;  /*End of present uniform section, t.b.d.*/

  while ( xend < x1 )
  { xbeg = xend;
    xend += 2;
    /*Figure out how far we can go before a vertice is seen*/
    while ( xend < x1 && !ckxvert(xend,y0,dy) ) xend += 2;
    if ( xend < x1 ) /*add to div list*/
    { *(divp+ndiv) = xend;  ndiv++; }

    /*Fill up the uniform section with divisions*/
    xb0 = (xbeg-x0)>>1;  xb1 = (xend-x0)>>1;
    for (pk=pk0; xb0<xb1; pk++)
    { if (*pk<0) /*end of list value, should never happen*/
        announce_bug("div_x(1)");
      xa0 = xb0;  xb0 += *pk;
      xa1 = xb1;  xb1 -= *pk;
      /*If total overlap, make each one identical*/
      if (xb1<=xa0 || xb0>=xa1) { xb0 = xa1;  xb1 = xa0; }
      /*If partial overlap, back each one off*/
      else if (xb0>xb1) { xb0 = xb1 = (xb0+xb1)>>1; }
      /*If ends too close, back each one off so last rect not tiny*/
      else if (xb1-xb0<xb0-xa0 && xb1!=xb0 && xa1-xa0>2)
      { dist = (xa1 - xa0) / 3;
        xb0 = xa0 + dist;  xb1 = xa1 - dist;
      }
      if ( xb0 <= xb1 )
      { *(divp+ndiv) = x0 + 2*xb0;  ndiv++; }
      if ( xb0 < xb1 )
      { *(divp+ndiv) = x0 + 2*xb1;  ndiv++; }     
    }
  } /*while*/
  if (ndiv>0)
    qsort((char *)divp,ndiv,sizeof(int),cmp_int);
  return(ndiv);
} /*div_x*/

int div_y(x0,y0,dx,y1,pk0,divp) int x0,y0,dx,y1,*pk0,*divp;
/*************************************************************/
/* Return divp,ndiv with gud sub divisions for rects.        */
/* (C) COPYRIGHT 1989 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03feb92 */
{ int *pk;
  int ya0,yb0,ya1,yb1;  /*2 y + y0 for msub coord*/
  int ybeg,yend,dist;
  int cmp_int();
  int ndiv;

  if ( y0 > y1 )
  { ya0 = y1;  y1 = y0;  y0 = ya0; }

  if ( y0 == y1 )  /*Nothing to do*/
  { return(0); }

  *divp = y0;
  *(divp+1) = y1;
  ndiv = 2;

  /*a is start, b is end of line segment*/
  /*y-0 is low end, y-1 is high end*/
  ya0 = yb0 = 0;  /*2 x then add y0 for msub coords*/
  ya1 = yb1 = 0;  /*ditto*/
  ybeg = y0;  /*Begining of uniform section*/
  yend = y0;  /*End of present uniform section, t.b.d.*/

  while ( yend < y1 )
  { ybeg = yend;
    yend += 2;
    /*Figure out how far we can go before a vertice is seen*/
    while ( yend < y1 && !ckyvert(x0,yend,dx) ) yend += 2;
    if ( yend < y1 ) /*add to div list*/
    { *(divp+ndiv) = yend;  ndiv++; }

    /*Fill up the uniform section with divisions*/
    yb0 = (ybeg-y0)>>1;  yb1 = (yend-y0)>>1;
    for (pk=pk0; yb0<yb1; pk++)
    { if (*pk<0) /*end of list value, should never happen*/
        announce_bug("div_y(1)");
      ya0 = yb0;  yb0 += *pk;
      ya1 = yb1;  yb1 -= *pk;
      /*If total overlap, make each one identical*/
      if (yb1<=ya0 || yb0>=ya1) { yb0 = ya1;  yb1 = ya0; }
      /*If partial overlap, back each one off*/
      else if (yb0>yb1) { yb0 = yb1 = (yb0+yb1)>>1; }
      /*If ends too close, back each one off so last rect not tiny*/
      else if (yb1-yb0<yb0-ya0 && yb1!=yb0 && ya1-ya0>2)
      { dist = (ya1 - ya0) / 3;
        yb0 = ya0 + dist;  yb1 = ya1 - dist;
      }
      if ( yb0 <= yb1 )
      { *(divp+ndiv) = y0 + 2*yb0;  ndiv++; }
      if ( yb0 < yb1 )
      { *(divp+ndiv) = y0 + 2*yb1;  ndiv++; }     
    }
  } /*while*/
  if (ndiv>0)
    qsort((char *)divp,ndiv,sizeof(int),cmp_int);
  return(ndiv);
} /*div_y*/

cmp_int(xp,yp)  int *xp,*yp;
/*************************************************************/
/* Simple compare of two integers.                           */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03feb92 */
{ if ( *xp > *yp ) return(1);
  if ( *xp < *yp ) return(-1);
  return(0);
} /*cmp_int*/

div_midpt(div0,div1,ndiv0p,ndiv1p,mdiv0p,mdiv1p)
      int *div0,*div1,*ndiv0p,*ndiv1p,*mdiv0p,*mdiv1p;
/*************************************************************/
/* Find (or make) consitent mid point for each side.         */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr08apr92 */
{ int ndiv0,ndiv1,mdiv0,mdiv1;
  int i,dist_a,dist_b,new_dist,ave;
  int cmp_int();

  ndiv0 = *ndiv0p;
  ndiv1 = *ndiv1p;

  /*End points on both edges must be the same*/
  if ( *div0 != *div1 || *(div0+ndiv0-1) != *(div1+ndiv1-1) )
    announce_bug("div_midpt(0)");
  if ( *div0 < 0 || *(div0+ndiv0-1) < *div0 )
    announce_bug("div_midpt(1)");

  ave = ( *div0 + *(div0+ndiv0-1) ) >> 1;
  /*Find indices of the points on both sides closest to the center*/
  dist_a = dist_b = *(div0+ndiv0-1);  /* >> first new_dist.*/
  for (i=0; i<ndiv0; i++)
  { new_dist = *(div0+i) - ave;
    if (new_dist<0) new_dist = - new_dist;
    if (new_dist < dist_a)
    { dist_a = new_dist;  mdiv0 = i; }
  }
  for (i=0; i<ndiv1; i++)
  { new_dist = *(div1+i) - ave;
    if (new_dist<0) new_dist = - new_dist;
    if (new_dist < dist_b)
    { dist_b = new_dist;  mdiv1 = i; }
  }

  /*Set the midpt divisions equal, this is important so that
    all small rectangles just to the left(say) of a big rect
    all have the same y-extent so they can be covered by a
    single big subsection.*/

  /*Go for equal value for mid points, if not already the case*/
  if ( *(div0+mdiv0) != *(div1+mdiv1) )
    /*Try to find a value in div0 equal to the mid_pt of div1*/
    for (i=0; i<ndiv0; i++)
      if ( *(div0+i) == *(div1+mdiv1) )
      { mdiv0 = i;  break; }

  if ( *(div0+mdiv0) != *(div1+mdiv1) )
    /*Try to find a value in div1 equal to the mid_pt of div0*/
    for (i=0; i<ndiv1; i++)
      if ( *(div1+i) == *(div0+mdiv0) )
      { mdiv1 = i;  break; }

  /*If still no match, insert a point in the worse div list*/
  if ( *(div0+mdiv0) != *(div1+mdiv1) )
  { if ( dist_a < dist_b ) /*Insert point into div1 list*/
    { *(div1+ndiv1) = *(div0+mdiv0);
      ndiv1++;
      if (ndiv1>0) qsort((char *)div1,ndiv1,sizeof(int),cmp_int);
      for (i=0; i<ndiv1; i++)
        if ( *(div1+i) == *(div0+mdiv0) )
        { mdiv1 = i;  break; }
    }
    else  /*Insert point into div0 list*/
    { *(div0+ndiv0) = *(div1+mdiv1);
      ndiv0++;
      if (ndiv0>0) qsort((char *)div0,ndiv0,sizeof(int),cmp_int);
      for (i=0; i<ndiv0; i++)
        if ( *(div0+i) == *(div1+mdiv1) )
        { mdiv0 = i;  break; }
    }

  }

  *ndiv0p = ndiv0;
  *ndiv1p = ndiv1;
  *mdiv0p = mdiv0;
  *mdiv1p = mdiv1;

} /*div_midpt*/

setup_pk(xmin,xmax,max_xinc,manhatten,size,xpk0)
			   int xmin,xmax,max_xinc,manhatten,size,*xpk0;
/*************************************************************/
/* Set up spacing for subsection sizes.                      */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr03feb92 */
{ int *xpk;
  int minx,maxx;
  int cmp_yx();

  minx = (xmin <= 0) ? 1 : xmin;
  maxx = (xmax <= 0) ? 1 : xmax;
  if ( maxx > max_xinc ) maxx = max_xinc;
  if ( minx > maxx ) minx = maxx;

  /*Always start w/1 so that staircase edge filled OK if not a manhatten polygon*/
  *xpk0 = (manhatten) ? minx : 1;
  *(xpk0+1) = 2 * minx;
  if ( *(xpk0+1) > maxx ) *(xpk0+1) = maxx;

  for (xpk=xpk0+2; xpk-xpk0<size; xpk++)
  { *xpk = 2 * *(xpk-1);
    if ( *xpk > maxx ) *xpk = maxx;
  }
  *(xpk0+size-1) = -1;  /*If we ever use this value, we have a bug*/

} /*setup_pk*/

find_big_rect(cells,big_rect) Ipts *cells;  int big_rect[4];
/*************************************************************/
/* Find corners of large rect in cell list and rm from cells.*/
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04feb92 */
{ int *ip,*ip0,*ip1,*ip_stop;
  int *jp,*jp1;
  int ix0,ix1,iy1,jx0,jx1,jy0,area0,area1,area2;
  int key[2];
  int j,nx,length;
  int x0,y0,x1,y1,more;
  int cmp_yx();

  if (cells->n <= 0)
  { big_rect[0] = big_rect[1] = big_rect[2] = big_rect[3] = 0;
    return;
  }

  /*Make sure the cells are sorted such that the first cell is
    the upper left corner (y axis is straight down) and cells
    are sorted by rows.*/
  sort_ipts(cells,cmp_yx);

  /*Find the row with the longest length for the same y cood*/
  ip_stop = cells->ipt0 + cells->n * cells->size;
  ip0 = ip1 = NULL;
  length = 0;
  jp = cells->ipt0;
  while (jp < ip_stop)
  { x0 = x1 = *jp;
    y0 = *(jp+1);
    ip = jp;  /*Save ptr to start of row*/
    jp += cells->size;
    while ( jp < ip_stop && *jp == x1+2 && *(jp+1) == y0 )
    { x1 += 2;
      jp += cells->size;
    }
    if ( length < x1 - x0 + 2 )
    { length = x1 - x0 + 2;
      ip0 = ip - cells->size; /*Ptr to cell b4 first cell of longest row*/
      ip1 = jp; /*Ptr to cell after end of longest row*/
    }
  }

  /*Set up initial big rect*/
  x0 = *(ip0+cells->size);
  x1 = x0 + length - 2;
  y0 = y1 = *(ip0+1+cells->size);

  ip = jp = NULL;
  more = 1;
  /*Find the largest area big rect possible*/
  while (more)
  { more = 0;

    /*Get info for increasing y1 option*/
    /*ip will be start of candidate row, ix0..ix1,iy1*/
    if (ip==NULL)
    { ip = ip1;
      while ( ip < ip_stop && (*ip < x0 || *(ip+1) == y1) ) ip += cells->size;
      if ( ip < ip_stop && *(ip+1) == y1+2 )
      { ip1 = ip + cells->size;
        ix0 = ix1 = *ip;
        iy1 = y1+2;
        while ( ip1 < ip_stop && *ip1 == ix1+2 && *ip1 <= x1 && *(ip1+1) == iy1 )
        { ix1 += 2;
          ip1 += cells->size;
        }
      }
      else
      { ix0 = ix1 = -1; }
    }

    /*Get info for decreasing y0 option*/
    /*jp will be start of candidate row, jx0..jx1,jy0*/
    if (jp==NULL)
    { jp1 = ip0;
      while ( jp1 >= cells->ipt0 && (*jp1 > x1 || *(jp1+1) == y0) ) jp1 -= cells->size;
      if ( jp1 > cells->ipt0 && *(jp1+1) == y0-2 )
      { jp = jp1 - cells->size; /*jp1 is last cell in candidate row*/
        jx0 = jx1 = *jp1;
        jy0 = y0-2;
        while ( jp >= cells->ipt0 && *jp == jx0-2 && *jp >= x0 && *(jp+1) == jy0 )
        { jx0 -= 2;
          jp -= cells->size;
        }
        ip0 = jp; /*Start point for next down search, just b4 candidate row*/
        jp += cells->size; /*Start of candidate row*/
      }
      else
      { jx0 = jx1 = -1; }
    }

    /*Now calculate area for each of three options*/
    /*Option 0, stay with present rectangle, ie, quit*/
    area0 = ( x1 - x0 + 2) * ( y1 - y0 + 2 );

    /*Option 1, increase y1*/
    if (ix1<0)
      area1 = 0;
    else
      area1 = (  ((x1<ix1)?x1:ix1) - ((x0>ix0)?x0:ix0) + 2  ) * ( iy1 - y0 + 2 );

    /*Option 2, decrease y0*/
    if (jx1<0)
      area2 = 0;
    else
      area2 = (  ((x1<jx1)?x1:jx1) - ((x0>jx0)?x0:jx0) + 2  ) * ( y1 - jy0 + 2 );

    /*Check for option 1 being best*/
    if ( area1>area0 && area1>=area2 )
    { x1 = (x1<ix1) ? x1 : ix1;
      x0 = (x0>ix0) ? x0 : ix0;
      y1 = iy1;
      ip = NULL; /*pull in another candidate, next time thru loop*/
      more = 1;
    }

    /*Check for option 2 being best*/
    else if ( area2>area0 && area2>=area1 )
    { x1 = (x1<jx1) ? x1 : jx1;
      x0 = (x0>jx0) ? x0 : jx0;
      y0 = jy0;
      jp = NULL; /*pull in another candidate, next time thru loop*/
      more = 1;
    }
  }

  /*Now delete all the cells which fall inside big_rect*/
  nx = (x1 - x0 + 2) >> 1;
  for (j=y1; j>=y0; j -= 2)
  { key[0] = x0;
    key[1] = j;
    ip = find_ipts(cells,key);
    rm_nipts(cells,ip,nx);
  }

  /*big_rect calls out the outside corners of the area.*/
  big_rect[0] = x0 - 1;
  big_rect[1] = y0 - 1;
  big_rect[2] = x1 + 1;
  big_rect[3] = y1 + 1;
} /*find_big_rect*/ 

attach0(rects,y0,y1,x) Ipts *rects;  int y0,y1,x;
/*************************************************************/
/* Make all rects falling on side 0 boundary attached OK.    */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04feb92 */
{ int ilim,i,j;
  int *ip,*jp;
  int key[4];

  /*The ip rectangle is on edge 0 inside big_rect*/
  /*The jp rectangle is on edge 0 outside big_rect*/

  ilim = rects->n;  /*No need to ck rects added in this routine*/
  for (i=0; i<ilim; i++)
  { ip = rects->ipt0 + i * rects->size; /*ipt0 might chng during loop*/
    /*check left x edge of rectangle*/
    if ( *ip == x && *(ip+1) >= y0 && *(ip+1) < y1)
      for (j=0; j<rects->n; j++)
      { jp = rects->ipt0 + j * rects->size;
        if ( *(jp+2) == x )
        { /*ck for improper overlap of ip..jp&ip..jp rectangle edges*/
          if ( *(ip+3) > *(jp+1) && *(ip+3) < *(jp+3) && *(ip+1) < *(jp+1) )
          { key[0] = *jp;  key[1] = *(ip+3);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+3) = *(ip+3);
            if ( *(jp+1) == *(jp+3) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
            if (*(ip+1) != y0) j = rects->n; /*terminate loop*/
          }
          /*ck for improper overlap of jp..ip&jp..ip rectangle edges*/
          /*needed only if first pt in big rect*/
          else if ( *(ip+1) == y0 && *(jp+3) > *(ip+1) && *(jp+3) < *(ip+3) && *(jp+1) < *(ip+1) )
          { key[0] = *jp;  key[1] = *(ip+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+3) = *(ip+1);
            if ( *(jp+1) == *(jp+3) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
          }
        }
      } /*for j*/
  } /*for i*/
} /*attach0*/

attach1(rects,y0,y1,x) Ipts *rects;  int y0,y1,x;
/*************************************************************/
/* Make all rects falling on side 1 boundary attached OK.    */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04feb92 */
{ int ilim,i,j;
  int *ip,*jp;
  int key[4];

  /*The ip rectangle is on edge 1 inside big_rect*/
  /*The jp rectangle is on edge 1 outside big_rect*/

  ilim = rects->n;  /*No need to ck rects added in this routine*/
  for (i=0; i<ilim; i++)
  { ip = rects->ipt0 + i * rects->size; /*ipt0 might chng during loop*/
    /*check right x edge of rectangle*/
    if ( *(ip+2) == x && *(ip+1) >= y0 && *(ip+1) < y1)
      for (j=0; j<rects->n; j++)
      { jp = rects->ipt0 + j * rects->size;
        if ( *jp == x )
        { /*ck for improper overlap of ip..jp&ip..jp rectangle edges*/
          if ( *(ip+3) > *(jp+1) && *(ip+3) < *(jp+3) && *(ip+1) < *(jp+1) )
          { key[0] = *jp;  key[1] = *(ip+3);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+3) = *(ip+3);
            if ( *(jp+1) == *(jp+3) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
            if (*(ip+1) != y0) j = rects->n; /*terminate loop*/
          }
          /*ck for improper overlap of jp..ip&jp..ip rectangle edges*/
          /*needed only if first pt in big rect*/
          else if ( *(ip+1) == y0 && *(jp+3) > *(ip+1) && *(jp+3) < *(ip+3) && *(jp+1) < *(ip+1) )
          { key[0] = *jp;  key[1] = *(ip+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+3) = *(ip+1);
            if ( *(jp+1) == *(jp+3) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
          }
        }
      } /*for j*/
  } /*for i*/
} /*attach1*/

attach2(rects,x0,x1,y) Ipts *rects;  int x0,x1,y;
/*************************************************************/
/* Make all rects falling on side 2 boundary attached OK.    */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04feb92 */
{ int ilim,i,j;
  int *ip,*jp;
  int key[4];

  /*The ip rectangle is on edge 2 inside big_rect*/
  /*The jp rectangle is on edge 2 outside big_rect*/

  ilim = rects->n;  /*No need to ck rects added in this routine*/
  for (i=0; i<ilim; i++)
  { ip = rects->ipt0 + i * rects->size; /*ipt0 might chng during loop*/
    /*check low (top) y edge of rectangle*/
    if ( *(ip+1) == y && *ip >= x0 && *ip < x1)
      for (j=0; j<rects->n; j++)
      { jp = rects->ipt0 + j * rects->size;
        if ( *(jp+3) == y )
        { /*ck for improper overlap of ip..jp&ip..jp rectangle edges*/
          if ( *(ip+2) > *jp && *(ip+2) < *(jp+2) && *ip < *jp )
          { key[0] = *(ip+2);  key[1] = *(jp+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+2) = *(ip+2);
            if ( *jp == *(jp+2) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
            if (*ip != x0) j = rects->n; /*terminate loop*/
          }
          /*ck for improper overlap of jp..ip&jp..ip rectangle edges*/
          /*needed only if first pt in big rect*/
          else if ( *ip == x0 && *ip > *jp && *ip < *(jp+2) && *(ip+2) > *(jp+2) )
          { key[0] = *ip;  key[1] = *(jp+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+2) = *ip;
            if ( *jp == *(jp+2) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
          }
        }
      } /*for j*/
  } /*for i*/
} /*attach2*/

attach3(rects,x0,x1,y) Ipts *rects;  int x0,x1,y;
/*************************************************************/
/* Make all rects falling on side 3 boundary attached OK.    */
/* (C) COPYRIGHT 1992 JAMES C. RAUTIO.  ALL RIGHTS RESERVED. */
/*************************************************************/
/* jcr04feb92 */
{ int ilim,i,j;
  int *ip,*jp;
  int key[4];

  /*The ip rectangle is on edge 3 inside big_rect*/
  /*The jp rectangle is on edge 3 outside big_rect*/

  ilim = rects->n;  /*No need to ck rects added in this routine*/
  for (i=0; i<ilim; i++)
  { ip = rects->ipt0 + i * rects->size; /*ipt0 might chng during loop*/
    /*check high (bottom) y edge of rectangle*/
    if ( *(ip+3) == y && *ip >= x0 && *ip < x1)
      for (j=0; j<rects->n; j++)
      { jp = rects->ipt0 + j * rects->size;
        if ( *(jp+1) == y )
        { /*ck for improper overlap of ip..jp&ip..jp rectangle edges*/
          if ( *(ip+2) > *jp && *(ip+2) < *(jp+2) && *ip < *jp )
          { key[0] = *(ip+2);  key[1] = *(jp+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+2) = *(ip+2);
            if ( *jp == *(jp+2) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
            if (*ip != x0) j = rects->n; /*terminate loop*/
          }
          /*ck for improper overlap of jp..ip&jp..ip rectangle edges*/
          /*needed only if first pt in big rect*/
          else if ( *ip == x0 && *ip > *jp && *ip < *(jp+2) && *(ip+2) > *(jp+2) )
          { key[0] = *ip;  key[1] = *(jp+1);
            key[2] = *(jp+2);  key[3] = *(jp+3);
            *(jp+2) = *ip;
            if ( *jp == *(jp+2) ) /*If jp is now 0 area, remove it*/
            { rm_ipts(rects,jp); }
            add_ipts(rects,key);
          }
        }
      } /*for j*/
  } /*for i*/
} /*attach3*/
